package dumpUtils;

import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;

import commonj.sdo.DataObject;
import commonj.sdo.Property;
        public class DumpDataObject {
		
		public void dumpDataObject(DataObject inputDO) {
			dumpDataObject(inputDO, null);
		}
		
		public void dumpDataObject(DataObject inputDO, String comment) {
			System.out.println(" ");
			System.out.println("############ Start DataObject Dump ############");
			if (comment != null)
				System.out.println("User Supplied Comment = " + comment);
			dumpDO(inputDO, "|");
			System.out.println("############ End  DataObject Dump ############");
			System.out.println(" ");
		}

		private void dumpDO(DataObject inputDO, String indent) {
			if (inputDO != null) {
				System.out.println(indent + "### Start DO Dump ###");
				System.out.println(indent + "Type -> "
						+ inputDO.getType().getName());
				List properties = inputDO.getType().getProperties();
				for (Iterator j = properties.iterator(); j.hasNext();) {
					Property p = (Property) j.next();
					System.out.println(indent + "Property: " + p.getName());
					String pName = p.getName();
					Object pValue = inputDO.get(pName);
					if (DataObject.class.isInstance(pValue)) {
						dumpDO((DataObject) pValue, "|----" + indent);
					} else  if (EObjectContainmentEList.class.isInstance(pValue)) {
						System.out.println(indent + "   Type:  " + p.getType().getName());
						dumpEList((EObjectContainmentEList) pValue, "|----" + indent);
					} else {
						System.out.println(indent + "   Type:  " + p.getType().getName());
						System.out.println(indent + "   Value: " + pValue);
					}
				}
				System.out.println(indent + "### End   DO Dump ###");
			}
			return;
		}

		private void dumpEList(EObjectContainmentEList eList, String indent) {
			if (eList != null) {
				System.out.println(indent + "### Start EList Dump ###");
				int count = 1;
				for (Iterator k = eList.iterator(); k.hasNext();) {
					Object item = k.next();
					System.out.println(indent + "EList Item " + count++);
					if (DataObject.class.isInstance(item)) {
						dumpDO((DataObject) item, "|----" + indent);
					} else if (EObjectContainmentEList.class.isInstance(item)) {
						dumpEList((EObjectContainmentEList) item, "|----" + indent);
					} else {
						System.out.println(indent + "   Item: " + item);
					}
				}
				System.out.println(indent + "### End   EList Dump ###");
			}
			return;
		}
		
	}
